<template>
  <q-dialog v-model="computedShow">
    <q-card class="card">
      <q-bar class="bg-primary text-white"
        >Parameters
        <q-space />
      </q-bar>

      <q-card-section>
        <div class="bg-grey-2 q-pa-sm rounded-borders nunito row">
          <div class="col-4">
            <span class="text-h6">Loop mode</span>
            <q-option-group v-model="loopMode_computed" :options="loopOptions" color="primary" />
          </div>
          <div class="col-6 row items-center justify-start">
            <q-icon name="help" size="sm" color="grey-6" style="margin-right: 0.6em" />
            <span class="text-body2">{{ loopText }}</span>
          </div>
        </div>
      </q-card-section>

      <q-card-section>
        <q-tabs  inline-label v-model="selectedTab" >
          <q-tab name="testbed" class="text-black" icon="mdi-developer-board" label="Hardware" />
          <q-tab name="controllers" class="text-blue-7" icon="mdi-export" label="Controllers" />
          <q-tab name="references" class="text-teal" icon="mdi-sine-wave" label="References" />
        </q-tabs>
      </q-card-section>

      <q-card-section class="column">
        <q-tab-panels v-model="selectedTab" animated>
          <q-tab-panel
            :name="key"
            class="row justify-center items-center"
            v-for="(item, key) in experiment"
            :key="'key:' + key"
          >
            <q-card
              flat
              class="col-4 bg-grey-2 rounded-borders column"
              v-for="(entity, instanceName) in item"
              :key="instanceName"
              style="padding: 1em; margin-left: 2em"
            >
              <div class="col-2">
                <span class="text-h5 nunito"> {{ `${entity.name[0].toUpperCase()}${entity.name.slice(1)}` }}</span>
                <span class="text-overline" v-if="entity.name !== instanceName" style="margin-left: 1em">{{
                  `${instanceName.toUpperCase()} ${key.slice(0, key.length - 1).toUpperCase()}`
                }}</span>
              </div>
              <div class="column col">
                <div class="col-md-4" v-for="(parameter, parameterName) in entity.parameters" :key="parameterName">
                  <q-input
                    dense
                    v-model="entity.parameters[parameterName]"
                    :rules="[
                      (val) => !!val || 'Field is required',
                      (val) => val.split(',').every((value) => value.match(/[+-]?([0-9]*[.])?[0-9]+/)) || 'Field error',
                    ]"
                  >
                    <template v-slot:before>
                      <span class="text-body1 text-black" color="black">{{ parameterName }}</span>
                    </template>
                  </q-input>
                </div>
              </div>
            </q-card>
          </q-tab-panel>
        </q-tab-panels>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script lang="ts">
import { defineComponent, computed, reactive, PropType, ref } from 'vue';
import { TaskLoopMap } from 'src/models/experiment';

export default defineComponent({
  emits: ['update:show', 'update:loopMap', 'update:loopMode'],
  props: {
    show: {
      type: Boolean,
      default: () => false,
    },
    loopMap: {
      type: Object as PropType<TaskLoopMap>,
      default: () => {
        return {
          testbed: {
            testbed: {
              parameters: {},
            },
          },
          controllers: {},
          references: {},
        };
      },
    },
    loopMode: {
      type: String,
      default: () => 'cartesian'
    }
  },

  setup(props, { emit }) {
    const computedShow = computed({
      get: () => {
        return props.show;
      },
      set: (value: boolean) => {
        emit('update:show', value);
        if (!value) emit('update:loopMap', JSON.parse(JSON.stringify(experiment)));
      },
    });

    const experiment = reactive(JSON.parse(JSON.stringify(props.loopMap)) as TaskLoopMap);

    const selectedTab = ref('controllers');

    const loopOptions = [
      {
        label: 'Cartesian product',
        value: 'cartesian',
        text: 'Loop over the set of all possible ordered pairs',
      },
      {
        label: 'Iterative',
        value: 'iterative',
        text: 'Iterate over the columns',
      },
    ];

    const loopText = computed(() => {
      return loopOptions.find((option) => option.value == props.loopMode)?.text;
    });

    const loopMode_computed = computed({
      get: () => props.loopMode,
      set: (value: string) => emit('update:loopMode', value)
    })

    return {
      computedShow,
      experiment,
      loopOptions,
      loopText,
      selectedTab,
      loopMode_computed
    };
  },
});
</script>

<style lang="sass" scoped>
.card
  width: 100%
  max-width: 70vw
  min-height: 70vh
  max-height: 85vh
</style>
